use strict;
package component_utils;

sub get_args(@)
{
  my $options = {};
  for my $arg (@_)
  {
    if ($arg =~ /--(\S+)=(\S+)$/)
    {
      my $key = $1;
      my $value = $2;
      $options->{$key} = $value;
    }
    if ($arg =~ /--(\S+)$/)
    {
      my $key = $1;
      my $value = undef;
      $options->{$key} = $value;
    }
  }

  return $options;
}

1;

