package spi_slave::sync;
use europa_module_factory;
@ISA = qw(europa_module_factory);

use strict;

sub add_contents_to_module
{
  my $this = shift;
  my $module = $this->module();

  # Inputs:
  my @inputs = qw(SCLK SS MOSI);
  for my $input (@inputs)
  {
    $module->add_contents(
      e_register->new({
        delay => 2,
        enable => "1'b1",
        in => $input,
        out => "sync_" . $input,
      }),
    );
  }

  # SS_n is active low.  I've pretended it's active high, so that
  # its reset value can be 0.  Fix up the input and output now.
  $module->add_contents(
    e_assign->new({lhs => "SS", rhs => "~SS_n",}),
    e_assign->new({lhs => "sync_SS_n", rhs => "~sync_SS",}),
  );
}

sub get_fields
{
  my $class = shift;

  my %fields = (
  );

  return \%fields;
}

1;

