package spi_slave::tx;
use europa_module_factory;
@ISA = qw(europa_module_factory);

use strict;

sub add_contents_to_module
{
  my $this = shift;
  my $module = $this->module();

  my $dw = $this->datawidth();
  my $msb = $dw - 1;
  my $msb2 = $dw - 2;

  my $miso_index = $this->lsbfirst() ? 0 : $msb;
  $module->add_contents(
    e_assign->new({
      lhs => "MISO",
      rhs => "txshift[$miso_index]",
    }),
  );

  my $p1_txshift = "txshift_load ? tx_fifo_readdata : " .
    "shift ? " . 
    ($this->lsbfirst() ? "{1'b0, txshift[$msb : 1]}" : 
      "{txshift[$msb2 : 0], 1'b0}") .
      " : txshift";
  $module->add_contents(
    e_assign->new({
      lhs => "p1_txshift",
      rhs => $p1_txshift,
    }),
  );
      
  $module->add_contents(
    e_register->new({
      out => {name => "txshift", width => $dw,},
      in => "p1_txshift",
      enable => "1'b1",
    }),
  );
}

sub get_fields
{
  my $class = shift;

  my %fields = (
    datawidth => { range => [1, undef], },
    lsbfirst => { range => [0, 1], },
  );

  return \%fields;
}

1;

